#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <math.h>

#include "misc.h"
#include "SDL.h"
unsigned char settab[4096];

#define XSIZE 400
#define YSIZE 350

void vector(int sx,int sy,int dx,int dy,int c);
int mousex,mousey;
SDL_Surface *thescreen;

int posx[81],posy[81];
unsigned long white,black,grey;
void randomize(void)
{
struct timeval tv;
	gettimeofday(&tv,0);
	srand(tv.tv_sec+tv.tv_usec);
}
void clear(void)
{
	memset(thescreen->pixels,0,XSIZE*YSIZE*2);
}
void colordot(int x,int y,int c)
{
	*((unsigned short *)thescreen->pixels+y*thescreen->pitch/2+x)=c;
}
void solidrect(int x,int y,int w,int h,unsigned long color)
{
int i,j;
	for(j=0;j<h;++j)
		for(i=0;i<w;++i)
			colordot(x+i,y+j,color);
}

void scrlock(void )
{
	if(SDL_MUSTLOCK(thescreen))
	{
		if ( SDL_LockSurface(thescreen) < 0 )
		{
			fprintf(stderr, "Couldn't lock display surface: %s\n",
								SDL_GetError());
			return;
		}
	}
}
void scrunlock(void)
{
	if(SDL_MUSTLOCK(thescreen))
		SDL_UnlockSurface(thescreen);
}
void update(void)
{
	SDL_UpdateRect(thescreen, 0, 0, 0, 0);
}

unsigned long maprgb(int r,int g,int b)
{
	return SDL_MapRGB(thescreen->format,r,g,b);
}




int pickcard(void)
{
int n;
	for(;;)
	{
		n=rand()%127;
		if(n<81) return n;
	}
}
/* Test set of 12 on cover of box */
char *testset[]={
"2BER",
"1TFB",
"3CFR",
"3TFG",
"1CLR",
"1BLB",
"1BER",
"1BEB",
"2BFG",
"1BFB",
"3BER",
"1CLB"};
char tab1[3]="123"; // 1, 2, 3
char tab2[3]="CBT"; // circle, box, triangle
char tab3[3]="ELF"; // empty, lined, full
char tab4[3]="RGB"; // red, green, blue

int look(char c,char *s)
{
	if(c==s[0]) return 0;
	if(c==s[1]) return 1;
	return 2;
}
int stringtonum(char *s)
{
int n;
	n=look(s[0],tab1);
	n+=3*look(s[1],tab2);
	n+=9*look(s[2],tab3);
	n+=27*look(s[3],tab4);
	return n;
}

void printcard(int n)
{
int v;
char str[16];
	v=n%3;n/=3;
	str[0]=tab1[v];
	v=n%3;n/=3;
	str[1]=tab2[v];
	v=n%3;n/=3;
	str[2]=tab3[v];
	v=n%3;n/=3;
	str[3]=tab4[v];
	str[4]=0;
	printf("%s",str);
}

int fixcard(int n)
{
int t,r;
	t=n%3;n/=3;
	r=1<<t;
	t=n%3;n/=3;
	r|=1<<(t+3);
	t=n%3;n/=3;
	r|=1<<(t+6);
	t=n%3;n/=3;
	r|=1<<(t+9);
	return r;
}

int validset(int *sets,int *list,int numsets)
{
int i,j,k;
int a,b,c;
	j=numsets*3;
	if(sets[j]>sets[j+1]) {i=sets[j];sets[j]=sets[j+1];sets[j+1]=i;}
	if(sets[j]>sets[j+2]) {i=sets[j];sets[j]=sets[j+2];sets[j+2]=i;}
	if(sets[j+1]>sets[j+2]) {i=sets[j+1];sets[j+1]=sets[j+2];sets[j+2]=i;}
	for(i=0;i<numsets;++i)
	{
		k=i*3;
		if(sets[k]==sets[j] && sets[k+1]==sets[j+1] && sets[k+2]==sets[j+2])
			return 0;
	}
	
	a=fixcard(list[sets[j]]);
	b=fixcard(list[sets[j+1]]);
	c=fixcard(list[sets[j+2]]);
	return settab[a|b|c]?1:0;
}

#define ONEBITS ((1<<0) | (1<<3) | (1<<6) | (1<<9))
#define NUMCARDS 12
/*
#define XSIZE 640
#define YSIZE 480
*/

#define CARDWIDTH 106
#define CARDHEIGHT 64

unsigned int colors[3];

#define YTAB 2000
int maxy,miny;
int mins[YTAB],maxs[YTAB];
int centerx,centery,rx,ry;

void initspecial()
{
	miny=YTAB-1;
	maxy=0;
	memset(maxs,0,sizeof(maxs));
	memset(mins,0x7f,sizeof(mins));
}

void specialdot(int x,int y,int c)
{
	if(y<miny) miny=y;
	if(y>maxy) maxy=y;
	if(x<mins[y]) mins[y]=x;
	if(x>maxs[y]) maxs[y]=x;
	colordot(x,y,c);
}

void fill(int color,int solid)
{
int x,y;
	for(y=miny;y<=maxy;++y)
	{
		int c=color;
		if(!solid && (((y-miny)>>1)%2)) c=0;
		for(x=mins[y];x<=maxs[y];++x)
			colordot(x,y,c);
	}
}

void vector(int sx,int sy,int dx,int dy,int c)
{
int diffx,diffy;
int stepx,stepy;
float val,delta;

	stepx=stepy=0;
	diffx=dx-sx;
	if(diffx<0) {diffx=-diffx;stepx=-1;}
	else if(diffx>0) stepx=1;
	diffy=dy-sy;
	if(diffy<0) {diffy=-diffy;stepy=-1;}
	else if(diffy>0) stepy=1;

	specialdot(sx,sy,c);

	if(diffx>diffy)
	{
		val=sy;
		delta=(dy-val)/diffx;
		val+=0.5;
		while(diffx--)
		{
			sx+=stepx;
			val+=delta;
			specialdot(sx,(int)val,c);
		}
	} else if(diffx<diffy)
	{
		val=sx;
		delta=(dx-val)/diffy;
		val+=0.5;
		while(diffy--)
		{
			sy+=stepy;
			val+=delta;
			specialdot((int)val,sy,c);
		}
	} else
		while(diffx--)
		{
			sx+=stepx;
			sy+=stepy;
			specialdot(sx,sy,c);
		}
}

void circle(int cx,int cy,int radius,int c)
{
int x,y,e;

	x=0;
	y=radius;
	e=3-(radius<<1);
	while(x<=y)
	{
		specialdot(cx+x,cy+y,c);
		specialdot(cx-x,cy+y,c);
		specialdot(cx+x,cy-y,c);
		specialdot(cx-x,cy-y,c);
		specialdot(cx+y,cy+x,c);
		specialdot(cx-y,cy+x,c);
		specialdot(cx+y,cy-x,c);
		specialdot(cx-y,cy-x,c);
		if(e<0)
			e+=(x<<2)+6;
		else
		{
			e+=((x-y)<<2)+10;
			--y;
		}
		++x;
	}
}

void box(int x,int y,int scale,int color)
{
	vector(x-scale,y-scale,x+scale,y-scale,color);
	vector(x+scale,y-scale,x+scale,y+scale,color);
	vector(x+scale,y+scale,x-scale,y+scale,color);
	vector(x-scale,y+scale,x-scale,y-scale,color);
}

void tri(int x,int y,int scale,int color)
{
	int c,s;
	c=scale;
	s=scale*577/1000;;
	vector(x+c,y+s,x-c,y+s,color);
	vector(x+c,y+s,x,y-scale,color);
	vector(x-c,y+s,x,y-scale,color);
}

void rendershape(int x,int y,int shape,int texture,int color)
{
int scale=CARDHEIGHT*2/9;


	x+=CARDWIDTH/6;
	y+=CARDHEIGHT/2;
	initspecial();
	switch(shape)
	{
	case 0: // circle
		circle(x,y,scale-1,color);
		circle(x,y,scale,color);
		circle(x,y,scale+1,color);
		break;
	case 1: // box
		box(x,y,scale-1,color);
		box(x,y,scale,color);
		box(x,y,scale+1,color);
		break;
	case 2: // triangle
		tri(x,y,scale-1,color);
		tri(x,y,scale,color);
		tri(x,y,scale+1,color);
		break;
	}
	if(texture)
	{
		fill(color,texture>1);
	}
}

#define GREY 50
void rendercard(int x,int y,int card)
{
int number;
int shape;
int texture;
int color;
	x-=CARDWIDTH/2;
	y-=CARDHEIGHT/2;
	number=card%3;card/=3;
	shape=card%3;card/=3;
	texture=card%3;card/=3;
	color=colors[card%3];
	solidrect(x+1,y+1,CARDWIDTH-2,CARDHEIGHT-2,grey);
	solidrect(x+3,y+3,CARDWIDTH-6,CARDHEIGHT-6,black);
	if(number==2)
	{
		rendershape(x,y,shape,texture,color);
		rendershape(x+CARDWIDTH/3,y,shape,texture,color);
		rendershape(x+CARDWIDTH*2/3,y,shape,texture,color);
	} else if(number==1)
	{
		rendershape(x+CARDWIDTH/3-CARDWIDTH/6,y,shape,texture,color);
		rendershape(x+CARDWIDTH/3+CARDWIDTH/6,y,shape,texture,color);
	} else
		rendershape(x+CARDWIDTH/3,y,shape,texture,color);

}

void showset(int *list,int c,int i,int j,int k)
{
int color;
#if 0
int t;
	t=c%6+1;
	color=maprgb((t&1)?255:0,(t&2)?255:0,(t&4)?255:0);
	vector(posx[i],posy[i],posx[j],posy[j],color);
	vector(posx[i],posy[i],posx[k],posy[k],color);
	vector(posx[j],posy[j],posx[k],posy[k],color);
#else
int fixx,fixy;
	color=maprgb(255,255,255);
	fixy=-CARDHEIGHT*14/32;
	fixx=-CARDWIDTH/2+c*6+3;
	c+='1';
	drawchar(posx[i]+fixx,posy[i]+fixy,c,color);
	drawchar(posx[j]+fixx,posy[j]+fixy,c,color);
	drawchar(posx[k]+fixx,posy[k]+fixy,c,color);
#endif

}

int findsets(int *sets,int found,int *list,int n)
{
int i,j,k,t;
int fixed[81];
int o;
int *fsets;

	fsets=sets;
	sets+=found*3;

	for(i=0;i<n;++i)
		fixed[i]=fixcard(list[i]);

	o=0;
	for(i=0;i<n-2;++i)
		for(j=i+1;j<n-1;++j)
			for(k=j+1;k<n;++k)
			{
				t=fixed[i]|fixed[j]|fixed[k];
				if(!settab[t]) continue;
				if(sets)
				{
					int new;
					for(new=0;new<found;++new)
						if(fsets[new*3]==i &&
							fsets[new*3+1]==j &&
							fsets[new*3+2]==k) break;
					if(new==found)
					{
						*sets++=i;
						*sets++=j;
						*sets++=k;
					}
				}
				++o;
			}
	return o;
}

void shuffle(int *list,int n)
{
unsigned char cardtab[81];
int i,j;
	memset(cardtab,0,sizeof(cardtab));
	for(i=0;i<NUMCARDS;++i)
	{
		for(;;)
		{
			j=pickcard();
			if(!cardtab[j]) break;
		}
		cardtab[j]=1;
		list[i]=j;
	}
}

int closest(int max)
{
int bestdist,bestnum=0,dist;
int dx,dy;
int i;
	bestdist=500000;
	for(i=0;i<max;++i)
	{
		dx=mousex-posx[i];
		dy=mousey-posy[i];
		dist=dx*dx+dy*dy;
		if(dist<bestdist)
		{
			bestdist=dist;
			bestnum=i;
		}
	}
	return bestnum;
}

void highlight(int n)
{
int x,y;
#define H1 5
	x=posx[n];
	y=posy[n];
	solidrect(x-H1-1,y-H1-1,H1*2+3,H1*2+3,black);
	solidrect(x-H1,y-H1,H1*2+1,H1*2+1,white);
}

int main(int argc,char **argv)
{
int i,j;
int cardlist[81];
int sets[50][3];
int found=0;
int redraw=0;
int clicks=0;
SDL_Event event;
unsigned long videoflags;
int exitflag = 0;

	randomize();
	if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}
	videoflags = 0;
	thescreen = SDL_SetVideoMode(XSIZE, YSIZE, 16, videoflags);
	if ( thescreen == NULL )
	{
		fprintf(stderr, "Couldn't set display mode: %s\n",
							SDL_GetError());
		exit(5);
	}
	SDL_WM_SetCaption("Sets by David Ashley", "Sets by David Ashley");


	colors[0]=maprgb(255,0,0); // red
	colors[1]=maprgb(0,255,0); // green
	colors[2]=maprgb(0,0,255); // blue
	white=maprgb(255,255,255);
	grey=maprgb(GREY,GREY,GREY);
	black=maprgb(0,0,0);

	for(i=0;i<4096;++i)
	{
		j=(i ^ (i>>1) ^ (i>>2) ^ ONEBITS) & ONEBITS;
		settab[i]=!j;
	}
	shuffle(cardlist,NUMCARDS);
// The following line loads up the demo set on the box
//	for(i=0;i<NUMCARDS;++i) cardlist[i]=stringtonum(testset[i]);
	found=0;
//	found=findsets(sets[0],0,cardlist,NUMCARDS);
	while(!exitflag)
	{
		scrlock();
		clear();
		for(i=0;i<NUMCARDS;++i)
		{
			int x,y;
#if 0
			int scale;
			float angle;
			angle=i*3.1415927*2/NUMCARDS;
			scale=YSIZE/2*7/8;
			x=XSIZE/2+scale*cos(angle);
			y=YSIZE/2+scale*sin(angle);
#else
			x=XSIZE/2+(i%3)*CARDWIDTH-CARDWIDTH;
			y=YSIZE/2+(i/3)*CARDHEIGHT-1.5*CARDHEIGHT;
#endif
			posx[i]=x;
			posy[i]=y;
		}
		for(i=0;i<NUMCARDS;++i)
		{
			rendercard(posx[i],posy[i],cardlist[i]);
		}
		for(i=0;i<found;++i)
		{
			showset(cardlist,i,sets[i][0],sets[i][1],sets[i][2]);
		}
		for(i=0;i<clicks;++i) highlight(sets[found][i]);
		i=findsets(0,0,cardlist,NUMCARDS);
		drawstring(5,5,white,"%d/%d",found,i);
		scrunlock();
		update();
		redraw=0;
		while(!redraw && !exitflag)
		{
			int code;
			while(SDL_PollEvent(&event))
			{
				switch(event.type)
				{
				case SDL_MOUSEMOTION:
					mousex=event.motion.x;
					mousey=event.motion.y;
					break;
				case SDL_MOUSEBUTTONDOWN:
					i=closest(NUMCARDS);
					for(j=0;j<clicks;++j)
						if(sets[found][j]==i) break;
					redraw=1;
					if(j==clicks)
					{
						sets[found][clicks++]=i;
						if(clicks==3)
						{
							clicks=0;
							found+=validset(sets[0],cardlist,found);
						}
					} else clicks=0;
					break;
				case SDL_KEYDOWN:
					code=event.key.keysym.sym;
					if(code==SDLK_ESCAPE) exitflag = 1;
					if(code==SDLK_SPACE)
					{
						redraw=1;
						shuffle(cardlist,NUMCARDS);
						clicks=0;
						found=0;
//						found=findsets(sets[0],cardlist,NUMCARDS);
					}
					if(code==SDLK_RETURN)
					{
						found=findsets(sets[0],found,cardlist,NUMCARDS);
						redraw=1;
					}
					break;
				case SDL_QUIT:
					exitflag = 1;
					break;
				}

			}
			SDL_Delay(10);
		}
	}
	SDL_Quit();
	return 0;
}
